function [tau1,tau2]=NE2_rek(q1_p,q2_p,q1_pp,q2_pp,FD1,FD2,v0_p,p1_p,p2_p,p1_pp,p2_pp )

%  Funktion zur Berechnung des Inversen Modells eines allgemeinen 2-Gelenkroboters, W. Weber Januar 2001
%  Letzte nderung:Februar 2001 (explizite Berechnung von M und b)
%  Teil B: W. Weber Januar 2001

global h1 h2 m1 m2 gx gy gz om0 om0p v0 z f3 n3 ISP1 ISP2 s1 s2 p1 p2  
global A10 A01 A21 A12 A32 A23


%4. Kinematische Berechnungen

om1=A01*(om0+h1*z*q1_p);
om1p=A01*(om0p+h1*(z*q1_pp+cross(om0,(z*q1_p))));
v1=A01*v0+cross(om1,p1)+(1-h1)*p1_p;
v1p=A01*v0_p+cross(om1p,p1)+cross(om1,cross(om1,p1))+(1-h1)*(p1_pp+cross(2*om1,p1_p));
vs1p=cross(om1p,s1)+cross(om1,cross(om1,s1))+v1p

om2=A12*(om1+h2*z*q2_p);
om2p=A12*(om1p+h2*(z*q2_pp+cross(om1,(z*q2_p))));
v2=A12*v1+cross(om2,p2)+(1-h2)*p2_p;
v2p=A12*v1p+cross(om2p,p2)+cross(om2,cross(om2,p2))+(1-h2)*(p2_pp+cross(2*om2,p2_p));
vs2p=cross(om2p,s2)+cross(om2,cross(om2,s2))+v2p

% 5. Dynamische Berechnungen

F2=m2*vs2p+(1-h2)*FD2*A12*z*q2_p
N2=ISP2*om2p+cross(om2,ISP2*om2)+h2*FD2*q2_p*A12*z;
f2=A32*f3+F2;
n2=A32*(n3+cross(A23*p2,f3))+cross(p2+s2,F2)+N2
tau2=(h2*n2'+(1-h2)*f2')*(A12*z)

F1=m1*vs1p+(1-h1)*FD1*A01*z*q1_p;
N1=ISP1*om1p+cross(om1,ISP1*om1)+h1*FD1*q1_p*A01*z;
f1=A21*f2+F1;
n1=A21*(n2+cross(A12*p1,f2))+cross(p1+s1,F1)+N1;
tau1=(h1*n1'+(1-h1)*f1')*(A01*z);
