%  Inverses Modell allgemeiner 2-Gelenkroboter, W. Weber Januar 2001
%  Letzte nderung:Februar 2001 (explizite Berechnung von M und b)
%  Teil B: Durchfhrung der Berechnungen 

global h1 h2 m1 m2 gx gy gz om0 om0p v0 z f3 n3 ISP1 ISP2 s1 s2 p1 p2 
global A10 A01 A21 A12 A32 A23

close; % letztes Bild lschen
			
% Einlesen der gespeicherten Parameter
load p_ne_2g par_2g;

h1=par_2g(1,1); % Gelenkarten
h2=par_2g(1,2);

gx=par_2g(1,3); % Vektor der Erdbeschleunigung
gy=par_2g(1,4);
gz=par_2g(1,5);

% 1. Startwerte 
om0=[0;0;0];
om0p=[0;0;0];
v0=[0;0;0];
v0p=[-gx;-gy;-gz]; % Startwert Beschleunigung

% Vorbesetzung z-Vektor
z=[0;0;1];


f3=[-par_2g(5,1);-par_2g(5,2);-par_2g(5,3)]; % externe Kraft (im Koordinatensystem K2)
n3=[-par_2g(5,4);-par_2g(5,5);-par_2g(5,6)];  % eternes Drehmoment ((im Koordinatensystem K2)

% Parameter Gelenk 1
teta1=par_2g(2,1);  % Wenn Gelenk 1 rotatorisch, wird dieser Wert berschrieben
d1=par_2g(2,3);  % Wenn Gelenk 1 translatorisch, wird dieser Wert berschrieben
m1=par_2g(1,6);
a1= par_2g(2,5);
FD1=par_2g(3,7);
alpha1=par_2g(2,7);
s1x=par_2g(3,1);
s1y=par_2g(3,2);
s1z=par_2g(3,3);
s1=[s1x; s1y; s1z];

ISP1=[par_2g(4,1) 0  0;
	0 par_2g(4,2) 0;
	0 0 par_2g(4,3)];
	
% Parameter Gelenk 2
teta2=par_2g(2,2);  % Wenn Gelenk 2 rotatorisch, wird dieser Wert berschrieben
d2=par_2g(2,4);  % Wenn Gelenk 2 translatorisch, wird dieser Wert berschrieben
m2=par_2g(1,7);
FD2=par_2g(3,8);
a2= par_2g(2,6);
alpha2=par_2g(2,8);
s2x=par_2g(3,4);
s2y=par_2g(3,5);
s2z=par_2g(3,6);
s2=[s2x; s2y; s2z];

ISP2=[par_2g(4,4) 0  0;
	0 par_2g(4,5) 0;
	0 0 par_2g(4,6)];
	   	
' Geben Sie jetzt den aktuellen Bewegungszustand ein:'

if h1==1 
q1=input('Winkel Gelenk 1 q1=teta1 in rad: ')
q1p=input('Winkelgeschwindigkeit Gelenk 1 q1p=teta1p in rad/s: ')
q1pp=input('Winkelbeschleunigung Gelenk 1 teta1pp=q1pp in rad/s^2: ')

% Konstanter Parameter d1 fr h1=1 
d1= par_2g(2,3);

A10=[cos(q1),-sin(q1)*cos(alpha1),sin(q1)*sin(alpha1);
   sin(q1),cos(q1)*cos(alpha1),-cos(q1)*sin(alpha1);
   0,sin(alpha1),cos(alpha1)];
A01=A10';
%p1, p1p, p1pp in Abhngigkeit von a1,alpha1, d1
p1=[a1; d1*sin(alpha1) ; d1*cos(alpha1)];
p1p=[0;0;0]; % bei Drehgelenk keine nderung von p1
p1pp=[0;0;0];

else
q1=input('Schublnge Gelenk q1=d1 in m: ')
q1p=input('Geschwindigkeit Gelenk 1 q1p=d1p in m/s: ')
q1pp=input('Beschleunigung Gelenk 1 q1pp=d1pp in m/s^2: ')

% Konstanter Parameter teta1 fr h1=1 
teta1= par_2g(2,1);

A10=[cos(teta1),-sin(teta1)*cos(alpha1),sin(teta1)*sin(alpha1);
   sin(teta1),cos(teta1)*cos(alpha1),-cos(teta1)*sin(alpha1);
   0,sin(alpha1),cos(alpha1)];
A01=A10';
%p1 in Abhngigkeit von a1,alpha1, d1
p1=[a1; q1*sin(alpha1) ; q1*cos(alpha1)]; % q1=d1
p1p=[0;q1p*sin(alpha1); q1p*cos(alpha1)];
p1pp=[0;q1pp*sin(alpha1); q1pp*cos(alpha1)];

end

if h2==1 
q2=input('Winkel Gelenk 2 q2=teta2 in rad: ')
q2p=input('Winkelgeschwindigkeit Gelenk 2 q2p=teta2p in rad/s: ')
q2pp=input('Winkelbeschleunigung Gelenk 2 teta2pp=q2pp in rad/s^2: ')

% Konstanter Parameter d2 fr h2=1 
d2= par_2g(2,4);

A21=[cos(q2),-sin(q2)*cos(alpha2),sin(q2)*sin(alpha2);
   sin(q2),cos(q2)*cos(alpha2),-cos(q2)*sin(alpha2);
   0,sin(alpha2),cos(alpha2)]
A12=A21'

%p2 in Abhngigkeit von a2,alpha2, d2
p2=[a2; d2*sin(alpha2) ; d2*cos(alpha2)];
p2p=[0;0;0]; % bei Drehgelenk keine nderung von p2
p2pp=[0;0;0];

else

q2=input('Schublnge Gelenk q2=d2 in m: ')
q2p=input('Geschwindigkeit Gelenk 2 q2p=d2p in m/s: ')
q2pp=input('Beschleunigung Gelenk 2 q2pp=d2pp in m/s^2: ')

% Konstanter Parameter teta2 fr h2=1 
teta2= par_2g(2,2);

A21=[cos(teta2),-sin(teta2)*cos(alpha2),sin(teta2)*sin(alpha2);
   sin(teta2),cos(teta2)*cos(alpha2),-cos(teta2)*sin(alpha2);
   0,sin(alpha2),cos(alpha2)];

A12=A21';
%p2 in Abhngigkeit von a2,alpha2, d2
p2=[a2; q2*sin(alpha2) ; q2*cos(alpha2)]; % q2=d2
p2p=[0;q2p*sin(alpha2); q2p*cos(alpha2)];
p2pp=[0;q2pp*sin(alpha2); q2pp*cos(alpha2)];


end


A32=[1,0,0;
   0,1,0;
   0,0,1];

A23=A32';


% Aufruf UP zur berechnung von tau1, tau2 
[tau1,tau2]=NE2_rek(q1p,q2p,q1pp,q2pp,FD1,FD2,v0p,p1p,p2p,p1pp,p2pp )

% Berechnung der einzelnen Systemteile

% Berechnungsformel :function [tau1,tau2]=NE2_rek(q1p,q2p,q1pp,q2pp,FD1,FD2,v0p,p1p,p2p,p1pp,p2pp )
[b1 b2]= NE2_rek(q1p,q2p,0,0,FD1,FD2,v0p,p1p,p2p,[0;0;0],[0;0;0] ); 
disp('Vektor b')
bvek=[b1;b2]

% Ermittlung der Matrix M und C
% Fr p1p, p2p p1pp und p2pp muss wegen unterschiedlichem Verhalten fr rotatorische
% und translatorische Gelenke bei setzen von qip=1, qipp=1  unterschiedlich 
% verfahren werden
%
if h1==1
p1p_ers=[0;0;0];
p1pp_ers=[0;0;0];
else
p1p_ers=[0;sin(alpha1); cos(alpha1)]; % es wurde q1p=1 gesetzt 
p1pp_ers=[0;sin(alpha1); cos(alpha1)]; % es wurde q1pp=1 gesetzt 
end

if h2==1
p2p_ers=[0;0;0];
p2pp_ers=[0;0;0];
else
p2p_ers=[0;sin(alpha2); cos(alpha2)]; % es wurde q2p=1 gesetzt 
p2pp_ers=[0;sin(alpha2); cos(alpha2)]; % es wurde q2pp=1 gesetzt 
end
 
[M11 M21]=NE2_rek(0,0,1,0,FD1,FD2,[0;0;0],[0;0;0],[0;0;0],p1pp_ers,[0;0;0]);
[M12 M22]=NE2_rek(0,0,0,1,FD1,FD2,[0;0;0],[0;0;0],[0;0;0],[0;0;0],p2pp_ers);
disp('Matrix M(q), hier Mmat')
Mmat=[M11 M12; M21 M22]
%[tau1,tau2]=NE2_rek(q1p,q2p,q1pp,q2pp,FD1,FD2,v0p,p1p,p2p,p1pp,p2pp )

% Berechnung von G(q)
[g1,g2]=NE2_rek(0,0,0,0,FD1,FD2,v0p,[0;0;0],[0;0;0],[0;0;0],[0;0;0] );
disp('Vektor G(q), hier gvek')
gvek=[g1;g2]


% Berechnung von C(q)
% Zuerst Berechnung von C_ges(q) fr qp1=1 und qp2=1 
[cges1,cges2]=NE2_rek(1,1,0,0,0,0,[0;0;0],p1p_ers,p2p_ers,[0;0;0],[0;0;0] );

% Berechnung der ersten und dritten Spalte: Zentripetalkrfte/momente
[c11,c21]=NE2_rek(1,0,0,0,0,0,[0;0;0],p1p_ers,[0;0;0],[0;0;0],[0;0;0]);
[c13,c23]=NE2_rek(0,1,0,0,0,0,[0;0;0],[0;0;0],p2p_ers,[0;0;0],[0;0;0]);



% Berechnung der zweiten Spalte: Corioliskrfte/momente
ccor=[cges1;cges2]-[c11;c21]-[c13;c23];
c12=ccor(1,1);
c22=ccor(2,1);

% Matrix cmat:
cmat=[[c11; c21] [c12; c22] [c13; c23]]

	

% Berechnung der Matrix R der Reibungseinflsse	
%[tau1,tau2]=NE2_rek(q1p,q2p,q1pp,q2pp,FD1,FD2,v0p,p1p,p2p,p1pp,p2pp )
[R11,R21]=NE2_rek(1,0,0,0,FD1,FD2,[0;0;0],p1p_ers,[0;0;0],[0;0;0],[0;0;0] );
[R12,R22]=NE2_rek(0,1,0,0,FD1,FD2,[0;0;0],[0;0;0],p2p_ers,[0;0;0],[0;0;0] );
% da bei obiger Berechnung die Zentripetaleinflsse bercksichtigt werden, muss
% mit c11, c21 c13 und c23 korrigiert werden 
R=[R11-c11 R12-c13 
 R21-c21 R22-c23]