function [tau1,tau2]=N_E_2G_symb(q,v0p,qp,qpp,p1p,p2p,p1pp,p2pp,FD,f3,n3)

global h1 h2 m1 m2 gx gy gz om0 om0p v0 z  ISP1 ISP2 s1 s2 p1 p2 
global A10 A01 A21 A12 A32 A23

% global q1 q2 qp1 qp2 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%  
%  Berechnung des symbolischen inversen Modells mit dem 
%  Newton-Euler-Verfahren. Welche Systemteile berechnet werden, wird
%  durch die Eingabe gesteuert
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Kinematische Berechnungen

om1=A01*(om0+h1*z*qp(1));
om1p=A01*(om0p+h1*(z*qpp(1)+cross(om0,(z*qp(1)))));
v1=A01*v0+cross(om1,p1)+(1-h1)*p1p;
v1p=A01*v0p+cross(om1p,p1)+cross(om1,cross(om1,p1))+(1-h1)*(p1pp+cross(2*om1,p1p));
vs1p=cross(om1p,s1)+cross(om1,cross(om1,s1))+v1p;

om2=A12*(om1+h2*z*qp(2));
om2p=A12*(om1p+h2*(z*qpp(2)+cross(om1,(z*qp(2)))));
v2=A12*v1+cross(om2,p2)+(1-h2)*p2p;
%vs2=v2+cross(om2,s2)
v2p=A12*v1p+cross(om2p,p2)+cross(om2,cross(om2,p2))+(1-h2)*(p2pp+cross(2*om2,p2p));
vs2p=cross(om2p,s2)+cross(om2,cross(om2,s2))+v2p ; 

% 5. Dynamische Berechnungen

F2=m2*vs2p+(1-h2)*FD(2)*A12*z*qp(2);
N2=ISP2*om2p+cross(om2,ISP2*om2)+h2*FD(2)*qp(2)*A12*z;
f2=A32*f3+F2;
n2=A32*(n3+cross(A23*p2,f3))+cross(p2+s2,F2)+N2;
tau2=(h2*transpose(n2)+(1-h2)*transpose(f2))*(A12*z);

F1=m1*vs1p+(1-h1)*FD(1)*A01*z*qp(1);
N1=ISP1*om1p+cross(om1,ISP1*om1)+h1*FD(1)*qp(1)*A01*z;
f1=A21*f2+F1;
n1=A21*(n2+cross(A12*p1,f2))+cross(p1+s1,F1)+N1;
tau1=(h1*transpose(n1)+(1-h1)*transpose(f1))*(A01*z); 

