%  Inverses Modell 2-Gelenkroboter RT siehe Buch Bild 2.16 und Kap. 6.2.5 

%  Bewegungsmessung / Eingabe der Messwerte 

% 2. Bewegungsmessung / Eingabe der Messwerte 

q1=input('Winkel q1=teta1=q1 in rad: ')
q2=input('Schublnge q2=d2 in m: ')
q1p=input('Winkelgeschwindigkeit Gelenk 1 q1p=teta1p in rad/s: ')
q2p=input('Schubgeschwindigkeit Gelenk 2 q2p=d2p in m/s: ')
q1pp=input('Winkelbeschleunigung Gelenk 1 teta1pp=q1pp in rad/s^2: ')
q2pp=input('Beschleunigung Gelenk 2 q2pp=d2pp in m/s^2: ')
g=input('Erdbeschleunigung g in m/s^2: ')


% z-Vektor, s-Vektoren, p-Vektoren

% z-Vektor, s-Vektoren, p-Vektoren
z=[0;0;1];
s1=[;0;0;0.25];
s2=[0;0;-0.25];
p1=[0;0;0];
p1p=[0;0;0];
p1pp=[0;0;0];
p2=[;0;0;q2];
p2p=[;0;0;q2p];
p2pp=[;0;0;q2pp]; % 

h1=1; % Drehgelnk 
h2=0; % Schubgelenk


% Massen, Trgheiten, Koeffizienten der geschwindigkeitsabhngigen Reibung 

m1=40;
m2=20;


ISP1=[2.8,0,0;
   0,2.8,0;
   0,0,1];

ISP2=[0.8,0,0;
   0,0.8,0;
   0,0,0.2];

FD1=0;
FD2=0;

% 1. startwerte und externe Krfte/Momente
om0=[0;0;0];
om0p=[0;0;0];
v0=[0;0;0];
v0p=[0;g;0];
f3=[0;0;0];
n3=[0;0;0];


% 3. Rotationsmatrizen
A10=[cos(q1),0,-sin(q1);
   sin(q1),0,cos(q1);
   0,-1,0];

A21=[1,0,0;
   0,1,0;
   0,0,1];

A01=A10';
A12=A21';

A32=[1,0,0;
   0,1,0;
   0,0,1];

A23=A32';

%4. Kinematische Berechnungen

om1=A01*(om0+h1*z*q1p)
om1p=A01*(om0p+h1*(z*q1pp+cross(om0,(z*q1p))))
v1=A01*v0+cross(om1,p1)+(1-h1)*p1p;
v1p=A01*v0p+cross(om1p,p1)+cross(om1,cross(om1,p1))+(1-h1)*(p1pp+cross(2*om1,p1p))
vs1p=cross(om1p,s1)+cross(om1,cross(om1,s1))+v1p

om2=A12*(om1+h2*z*q2p)
om2p=A12*(om1p+h2*(z*q2pp+cross(om1,(z*q2p))))
v2=A12*v1+cross(om2,p2)+(1-h2)*p2p
v2p=A12*v1p+cross(om2p,p2)+cross(om2,cross(om2,p2))+(1-h2)*(p2pp+cross(2*om2,p2p))
vs2p=cross(om2p,s2)+cross(om2,cross(om2,s2))+v2p

% 5. Dnamische Berechnungen

F2=m2*vs2p+(1-h2)*FD2*A12*z*q2p
N2=ISP2*om2p+cross(om2,ISP2*om2)+h2*FD2*q2p*A12*z;
f2=A32*f3+F2;
n2=A32*(n3+cross(A23*p2,f3))+cross(p2+s2,F2)+N2;
tau2=(h2*n2'+(1-h2)*f2')*(A12*z)

F1=m1*vs1p+(1-h1)*FD1*A01*z*q1p;
N1=ISP1*om1p+cross(om1,ISP1*om1)+h1*FD1*q1p*A01*z;
f1=A21*f2+F1;
n1=A21*(n2+cross(A12*p1,f2))+cross(p1+s1,F1)+N1;
tau1=(h1*n1'+(1-h1)*f1')*(A01*z)


% Nun folgt die Einbeziehung des Getriebes und der Motoren

tau=[tau1;tau2];
qpp=[q1pp;q2pp];
qp=[q1p;q2p];
u1=160;
u2=160;

C1=0.36;
C2=0.433;
KMI1=1;
KMI2=1;
JA1=7.66e-4;
JA2=26.3e-4;
FM1=0.3E-3;
FM2=1.3E-3;

TG=[1/u1,0;
   0,1/u2];
SG=(inv(TG))';

JA=[JA1, 0 ;
   0, JA2];
FM=[FM1,0;
   0, FM2];
KM=[C1/KMI1,0;
   0, C2/KMI2]

US=inv(KM)*(inv(SG)*tau+JA*inv(TG)*qpp+FM*inv(TG)*qp)