
%function[]=P_ne2_eg()
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Programm P_ne2_eg , W. Weber, Maerz 2001
% 
% Es wird ein Menue zur Verfgung gestellt, um die konstanten Parameter
% und externen Krfte Momente eines Zweigelenkroboters eingeben bzw. verndern zu knnen
%
% Eingabeparameter:
% vorhergehende Einstellungen:  Matrix par_2g auf dem Mat-file p_ne_2g.mat  (liegt auf dem aktuellen Pfad)
% Falls dieses file nicht vorhanden ist, werden als Standardwerte die Parameter des 
% RV6 genommen.
% nderungen knnen in der jeweils zweiten Zeile der numerischen Angaben vorgenommen werden 
% und werden bernommen.
% Bei Bettigen des Button bernehmen, wird zur bernahme der aktuellen Werte das Programm
% P_ne1_sp.m aufgerufen.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
%
% close		% Letztes Fenster schlieen.


%	Grafikparameter f?r Bildschirmdarstellung

global scrmax;
% Ermitteln der eingestellten Bildschirmauflsung
scrformat=get(0,'ScreenSize');

% Breite und Hhe holen
scrb=scrformat(3);
scrh=scrformat(4);

if scrb==1280	   % Bildschirmbreite = 1280 ?
   scrmax=[241 248 794 530];
   scr01=[440 362 400 300];
   scr02=[440 332 400 350];
   scr03=[340 312 600 400];
   scr04_1=[241 536 394 242];
   scr04_2=[642 536 394 242];
   scr04_3=[440 248 397 242];
   else 
   if scrb==1152	   % Bildschirmbreite = 1152 ?
      scrmax=[177 184 794 530];
      scr01=[376 298 400 300];
      scr02=[376 268 400 350];
      scr03=[276 248 600 400];
      scr04_1=[177 472 394 242];
      scr04_2=[578 472 394 242];
      scr04_3=[376 184 397 242];
      else 
      if scrb==1024	   % Bildschirmbreite = 1024 ?
         scrmax=[113 120 794 530];
         scr01=[312 234 400 300];
         scr02=[312 204 400 350];
         scr03=[212 184 600 400];
         scr04_1=[113 408 394 242];
         scr04_2=[514 408 394 242];
         scr04_3=[312 120 397 242];
         else 
      scrb==800    % Bildschirmbreite =  800 ?
      scrmax=[3 40 794 530];
      scr01=[200 150 400 300];
      scr02=[200 120 400 350];
      scr03=[100 100 600 400];
      scr04_1=[200 300 200 150];
      scr04_2=[400 300 200 150];
      scr04_3=[300 150 200 150];
      end
   end
end

% Fenster ffnen 
afig=figure('Position',scrmax);

y1=485;    % Festlegen vertikaler Hhen
y2=y1-90;
y3=y2-90;
y4=y3-90;
y5=y4-90;

% Fenster ffnen 
%afig=figure('Position',scrmax);

% Text der Kopfzeilen.

%atex00 =uicontrol('Style','text','Position',[0  516 794 14],'String','FH Darmstadt Labor Robotertechnik - Berechnung des expliziten Inversens Modells eines beliebigen 2 Gelenkroboters','BackGroundColor',[0.9 0 0]);
%atex00a=uicontrol('Style','text','Position',[0  502 794 14],'String','Vorgabe der Struktur und der konstanten Parameter','BackGroundColor',[0.9 0 0]);

atex00 =uicontrol('Style','text','Position',[0  516 794 14],'String','Hochschule Darmstadt Zentrum fr Robotik - Berechnung des expliziten Inversens Modells eines beliebigen 2 Gelenkroboters','BackGroundColor',[0.7 0.7 0.7]);
atex00a=uicontrol('Style','text','Position',[0  502 794 14],'String','Vorgabe der Struktur und der konstanten Parameter','BackGroundColor',[0.7 0.7 0.7]);

%aueb10 =uicontrol('Style','text','Position',[29  y1 490  14],'String','Angaben zur Gelenkstruktur, Erdbeschleunigung, Massen (Startvektor v_0p zeigt in negativer Richtung von g)');
aueb10 =uicontrol('Style','text','Position',[29  y1 690  14],'String','Angaben zur Gelenkstruktur, Erdbeschleunigung, Massen (Startvektor v_0p zeigt in negativer Richtung von g)');
aueb11 =uicontrol('Style','text','Position',[29  y1-20  77  14],'String','h1');
aueb12 =uicontrol('Style','text','Position',[132 y1-20 77  14],'String','h2');
aueb13 =uicontrol('Style','text','Position',[235 y1-20 77  14],'String','gx');
aueb14 =uicontrol('Style','text','Position',[338 y1-20 77  14],'String','gy');
aueb15 =uicontrol('Style','text','Position',[442 y1-20 77  14],'String','gz');
aueb16 =uicontrol('Style','text','Position',[545 y1-20 77  14],'String','m1');
aueb17 =uicontrol('Style','text','Position',[648 y1-20 77  14],'String','m2');

aueb20 =uicontrol('Style','text','Position',[29  y2 729  14],'String','Denavit-Hartenberg Parameter in Grundstellung ');
aueb21 =uicontrol('Style','text','Position',[29  y2-20 77  14],'String','teta1');
aueb22 =uicontrol('Style','text','Position',[122 y2-20 77  14],'String','teta2');
aueb23 =uicontrol('Style','text','Position',[215 y2-20 77  14],'String','d1');
aueb24 =uicontrol('Style','text','Position',[308 y2-20 77  14],'String','d2');
aueb25 =uicontrol('Style','text','Position',[402 y2-20 77  14],'String','a1');
aueb26 =uicontrol('Style','text','Position',[495 y2-20 77  14],'String','a2');

aueb27 =uicontrol('Style','text','Position',[588 y2-20 77  14],'String','alpha1');
aueb28 =uicontrol('Style','text','Position',[681 y2-20 77  14],'String','alpha2');

aueb30 =uicontrol('Style','text','Position',[29  y3 592  14],'String','Vektoren s1, s2 vom Ursprung von K1 bzw. K2 zu den Armteilschwerpunkten');
aueb31 =uicontrol('Style','text','Position',[29  y3-20 77  14],'String','s1x');
aueb32 =uicontrol('Style','text','Position',[122 y3-20 77  14],'String','s1y');
aueb33 =uicontrol('Style','text','Position',[215 y3-20 77  14],'String','s1z');
aueb34 =uicontrol('Style','text','Position',[308 y3-20 77  14],'String','s2x');
aueb35 =uicontrol('Style','text','Position',[402 y3-20 77  14],'String','s2y');
aueb36 =uicontrol('Style','text','Position',[495 y3-20 77  14],'String','s2z');
aueb37 =uicontrol('Style','text','Position',[588 y3-20 77  14],'String','FD1');
aueb38 =uicontrol('Style','text','Position',[681 y3-20 77  14],'String','FD2');

aueb40 =uicontrol('Style','text','Position',[29  y4 592  14],'String','Hauptdiagonale beider Trgheitstensoren um den Schwerpunkt (Nebendiag. vernachlssigt)');
aueb41 =uicontrol('Style','text','Position',[29  y4-20 77  14],'String','I_xx_1');
aueb42 =uicontrol('Style','text','Position',[132 y4-20 77  14],'String','I_yy_1');
aueb43 =uicontrol('Style','text','Position',[235 y4-20 77  14],'String','I_zz_1');
aueb44 =uicontrol('Style','text','Position',[338 y4-20 77  14],'String','I_xx_2');
aueb45 =uicontrol('Style','text','Position',[441 y4-20 77  14],'String','I_yy_2');
aueb46 =uicontrol('Style','text','Position',[544 y4-20 77  14],'String','I_zz_2');

aueb50 =uicontrol('Style','text','Position',[29  y5 592  14],'String','Externe Krfte/Drehmomente (Es gilt: f3=-fex, n3=-nex, fex und nex sind in K2 dargestellt)');
aueb51 =uicontrol('Style','text','Position',[29  y5-20 77  14],'String','fex_x');
aueb52 =uicontrol('Style','text','Position',[132 y5-20 77  14],'String','fex_y');
aueb53 =uicontrol('Style','text','Position',[235 y5-20 77  14],'String','fex_z');
aueb54 =uicontrol('Style','text','Position',[338 y5-20 77  14],'String','nex_x');
aueb55 =uicontrol('Style','text','Position',[441 y5-20 77  14],'String','nex_y');
aueb56 =uicontrol('Style','text','Position',[544 y5-20 77  14],'String','nex_z');


if exist('p_ne_2g.mat')==2
	load p_ne_2g.mat
	% Hier werden die zuletzt benutzten Werte geladen.

% Vorgabe der Parameter h1, h2, g, m1 , m2  (RV2)


aedi11 =uicontrol('Style','edit','Position',[29 y1-60 77 20],'String',par_2g(1,1),'Callback',['set(atex11,''String'',','num2str(get(aedi11,''String''))),'],'BackGroundColor',[0.7 0.7 0.7]);
atex11 =uicontrol('Style','text','Position',[29 y1-40 77 14],'String',num2str(get(aedi11,'String')));
aedi12 =uicontrol('Style','edit','Position',[132 y1-60 77 20],'String',par_2g(1,2),'Callback',['set(atex12,''String'',','num2str(get(aedi12,''String''))),'],'BackGroundColor',[0.7 0.7 0.7]);
atex12 =uicontrol('Style','text','Position',[132 y1-40 77 14],'String',num2str(get(aedi12,'String')));
aedi13 =uicontrol('Style','edit','Position',[235 y1-60 77 20],'String',par_2g(1,3),'Callback',['set(atex13,''String'',','num2str(get(aedi13,''String''))),'],'BackGroundColor',[0.7 0.7 0.7]);
atex13 =uicontrol('Style','text','Position',[235 y1-40 77 14],'String',num2str(get(aedi13,'String')));
aedi14 =uicontrol('Style','edit','Position',[338 y1-60 77 20],'String',par_2g(1,4),'Callback',['set(atex14,''String'',','num2str(get(aedi14,''String''))),'],'BackGroundColor',[0.7 0.7 0.7]);
atex14 =uicontrol('Style','text','Position',[338 y1-40 77 14],'String',num2str(get(aedi14,'String')));
aedi15 =uicontrol('Style','edit','Position',[442 y1-60 77 20],'String',par_2g(1,5),'Callback',['set(atex15,''String'',','num2str(get(aedi15,''String''))),'],'BackGroundColor',[0.7 0.7 0.7]);
atex15 =uicontrol('Style','text','Position',[442 y1-40 77 14],'String',num2str(get(aedi15,'String')));
aedi16 =uicontrol('Style','edit','Position',[545 y1-60 77 20],'String',par_2g(1,6),'Callback',['set(atex16,''String'',','num2str(get(aedi16,''String''))),'],'BackGroundColor',[0.7 0.7 0.7]);
atex16 =uicontrol('Style','text','Position',[545 y1-40 77 14],'String',num2str(get(aedi16,'String')));
aedi17 =uicontrol('Style','edit','Position',[648 y1-60 77 20],'String',par_2g(1,7),'Callback',['set(atex17,''String'',','num2str(get(aedi17,''String''))),'],'BackGroundColor',[0.7 0.7 0.7]);
atex17 =uicontrol('Style','text','Position',[648 y1-40 77 14],'String',num2str(get(aedi17,'String')));

% Vorgabe der Parameter teta1, teta2, d1, d2, a1, a2, alpha1, alpha2  (RV2)
aedi21 =uicontrol('Style','edit','Position',[29 y2-60 77 20],'String',par_2g(2,1),'Callback',['set(atex21,''String'',','num2str(get(aedi21,''String''))),'],'BackGroundColor',[0.7 0.7 0.7]);
atex21 =uicontrol('Style','text','Position',[29 y2-40 77 14],'String',num2str(get(aedi21,'String')));
aedi22 =uicontrol('Style','edit','Position',[122 y2-60 77 20],'String',par_2g(2,2),'Callback',['set(atex22,''String'',','num2str(get(aedi22,''String''))),'],'BackGroundColor',[0.7 0.7 0.7]);
atex22 =uicontrol('Style','text','Position',[122 y2-40 77 14],'String',num2str(get(aedi22,'String')));
aedi23 =uicontrol('Style','edit','Position',[215 y2-60 77 20],'String',par_2g(2,3),'Callback',['set(atex23,''String'',','num2str(get(aedi23,''String''))),'],'BackGroundColor',[0.7 0.7 0.7]);
atex23 =uicontrol('Style','text','Position',[215 y2-40 77 14],'String',num2str(get(aedi23,'String')));
aedi24 =uicontrol('Style','edit','Position',[308 y2-60 77 20],'String',par_2g(2,4),'Callback',['set(atex24,''String'',','num2str(get(aedi24,''String''))),'],'BackGroundColor',[0.7 0.7 0.7]);
atex24 =uicontrol('Style','text','Position',[308 y2-40 77 14],'String',num2str(get(aedi24,'String')));
aedi25 =uicontrol('Style','edit','Position',[402 y2-60 77 20],'String',par_2g(2,5),'Callback',['set(atex25,''String'',','num2str(get(aedi25,''String''))),'],'BackGroundColor',[0.7 0.7 0.7]);
atex25 =uicontrol('Style','text','Position',[402 y2-40 77 14],'String',num2str(get(aedi25,'String')));
aedi26 =uicontrol('Style','edit','Position',[495 y2-60 77 20],'String',par_2g(2,6),'Callback',['set(atex26,''String'',','num2str(get(aedi25,''String''))),'],'BackGroundColor',[0.7 0.7 0.7]);
atex26 =uicontrol('Style','text','Position',[495 y2-40 77 14],'String',num2str(get(aedi26,'String')));
aedi27 =uicontrol('Style','edit','Position',[588 y2-60 77 20],'String',par_2g(2,7),'Callback',['set(atex27,''String'',','num2str(get(aedi27,''String''))),'],'BackGroundColor',[0.7 0.7 0.7]);
atex27 =uicontrol('Style','text','Position',[588 y2-40 77 14],'String',num2str(get(aedi27,'String')));
aedi28 =uicontrol('Style','edit','Position',[681 y2-60 77 20],'String',par_2g(2,8),'Callback',['set(atex28,''String'',','num2str(get(aedi28,''String''))),'],'BackGroundColor',[0.7 0.7 0.7]);
atex28 =uicontrol('Style','text','Position',[681 y2-40 77 14],'String',num2str(get(aedi28,'String')));


% Eingabe von s1 und s2 

aedi31 =uicontrol('Style','edit','Position',[29 y3-60 77 20],'String',par_2g(3,1),'Callback',['set(atex31,''String'',','num2str(get(aedi31,''String''))),'],'BackGroundColor',[0.7 0.7 0.7]);
atex31=uicontrol('Style','text','Position',[29 y3-40 77 14],'String',num2str(get(aedi31,'String')));
aedi32 =uicontrol('Style','edit','Position',[122 y3-60 77 20],'String',par_2g(3,2),'Callback',['set(atex32,''String'',','num2str(get(aedi32,''String''))),'],'BackGroundColor',[0.7 0.7 0.7]);
atex32 =uicontrol('Style','text','Position',[122 y3-40 77 14],'String',num2str(get(aedi32,'String')));
aedi33 =uicontrol('Style','edit','Position',[215 y3-60 77 20],'String',par_2g(3,3),'Callback',['set(atex33,''String'',','num2str(get(aedi33,''String''))),'],'BackGroundColor',[0.7 0.7 0.7]);
atex33 =uicontrol('Style','text','Position',[215 y3-40 77 14],'String',num2str(get(aedi33,'String')));
aedi34 =uicontrol('Style','edit','Position',[308 y3-60 77 20],'String',par_2g(3,4),'Callback',['set(atex34,''String'',','num2str(get(aedi34,''String''))),'],'BackGroundColor',[0.7 0.7 0.7]);
atex34 =uicontrol('Style','text','Position',[308 y3-40 77 14],'String',num2str(get(aedi34,'String')));
aedi35 =uicontrol('Style','edit','Position',[402 y3-60 77 20],'String',par_2g(3,5),'Callback',['set(atex35,''String'',','num2str(get(aedi35,''String''))),'],'BackGroundColor',[0.7 0.7 0.7]);
atex35 =uicontrol('Style','text','Position',[402 y3-40 77 14],'String',num2str(get(aedi35,'String')));
aedi36 =uicontrol('Style','edit','Position',[495 y3-60 77 20],'String',par_2g(3,6),'Callback',['set(atex36,''String'',','num2str(get(aedi36,''String''))),'],'BackGroundColor',[0.7 0.7 0.7]);
atex36 =uicontrol('Style','text','Position',[495 y3-40 77 14],'String',num2str(get(aedi36,'String')));
aedi37 =uicontrol('Style','edit','Position',[588 y3-60 77 20],'String',par_2g(3,7),'Callback',['set(atex37,''String'',','num2str(get(aedi37,''String''))),'],'BackGroundColor',[0.7 0.7 0.7]);
atex37 =uicontrol('Style','text','Position',[588 y3-40 77 14],'String',num2str(get(aedi37,'String')));
aedi38 =uicontrol('Style','edit','Position',[681 y3-60 77 20],'String',par_2g(3,8),'Callback',['set(atex38,''String'',','num2str(get(aedi38,''String''))),'],'BackGroundColor',[0.7 0.7 0.7]);
atex38 =uicontrol('Style','text','Position',[681 y3-40 77 14],'String',num2str(get(aedi38,'String')));

% Eingabe von I1 und I2 (Hauptdiagonale)

aedi41 =uicontrol('Style','edit','Position',[30 y4-60 77 20],'String',par_2g(4,1),'Callback',['set(atex41,''String'',','num2str(get(aedi41,''String''))),'],'BackGroundColor',[0.7 0.7 0.7]);
atex41 =uicontrol('Style','text','Position',[30 y4-40 77 14],'String',num2str(get(aedi41,'String')));
aedi42 =uicontrol('Style','edit','Position',[133 y4-60 77 20],'String',par_2g(4,2),'Callback',['set(atex42,''String'',','num2str(get(aedi42,''String''))),'],'BackGroundColor',[0.7 0.7 0.7]);
atex42 =uicontrol('Style','text','Position',[133 y4-40 77 14],'String',num2str(get(aedi42,'String')));
aedi43 =uicontrol('Style','edit','Position',[236 y4-60 77 20],'String',par_2g(4,3),'Callback',['set(atex43,''String'',','num2str(get(aedi43,''String''))),'],'BackGroundColor',[0.7 0.7 0.7]);
atex43 =uicontrol('Style','text','Position',[236 y4-40 77 14],'String',num2str(get(aedi43,'String')));
aedi44 =uicontrol('Style','edit','Position',[339 y4-60 77 20],'String',par_2g(4,4),'Callback',['set(atex44,''String'',','num2str(get(aedi44,''String''))),'],'BackGroundColor',[0.7 0.7 0.7]);
atex44 =uicontrol('Style','text','Position',[339 y4-40 77 14],'String',num2str(get(aedi44,'String')));
aedi45 =uicontrol('Style','edit','Position',[442 y4-60 77 20],'String',par_2g(4,5),'Callback',['set(atex45,''String'',','num2str(get(aedi45,''String''))),'],'BackGroundColor',[0.7 0.7 0.7]);
atex45 =uicontrol('Style','text','Position',[442 y4-40 77 14],'String',num2str(get(aedi45,'String')));
aedi46 =uicontrol('Style','edit','Position',[545 y4-60 77 20],'String',par_2g(4,6),'Callback',['set(atex46,''String'',','num2str(get(aedi46,''String''))),'],'BackGroundColor',[0.7 0.7 0.7]);
atex46 =uicontrol('Style','text','Position',[545 y4-40 77 14],'String',num2str(get(aedi46,'String')));

% Eingabe der externen Krfte/Momente

aedi51 =uicontrol('Style','edit','Position',[30 y5-60 77 20],'String',par_2g(5,1),'Callback',['set(atex51,''String'',','num2str(get(aedi51,''String''))),'],'BackGroundColor',[0.7 0.7 0.7]);
atex51 =uicontrol('Style','text','Position',[30 y5-40 77 14],'String',num2str(get(aedi51,'String')));
aedi52 =uicontrol('Style','edit','Position',[133 y5-60 77 20],'String',par_2g(5,2),'Callback',['set(atex52,''String'',','num2str(get(aedi52,''String''))),'],'BackGroundColor',[0.7 0.7 0.7]);
atex52 =uicontrol('Style','text','Position',[133 y5-40 77 14],'String',num2str(get(aedi52,'String')));
aedi53 =uicontrol('Style','edit','Position',[236 y5-60 77 20],'String',par_2g(5,3),'Callback',['set(atex53,''String'',','num2str(get(aedi53,''String''))),'],'BackGroundColor',[0.7 0.7 0.7]);
atex53 =uicontrol('Style','text','Position',[236 y5-40 77 14],'String',num2str(get(aedi53,'String')));
aedi54 =uicontrol('Style','edit','Position',[339 y5-60 77 20],'String',par_2g(5,4),'Callback',['set(atex54,''String'',','num2str(get(aedi54,''String''))),'],'BackGroundColor',[0.7 0.7 0.7]);
atex54 =uicontrol('Style','text','Position',[339 y5-40 77 14],'String',num2str(get(aedi54,'String')));
aedi55 =uicontrol('Style','edit','Position',[442 y5-60 77 20],'String',par_2g(5,5),'Callback',['set(atex55,''String'',','num2str(get(aedi55,''String''))),'],'BackGroundColor',[0.7 0.7 0.7]);
atex55 =uicontrol('Style','text','Position',[442 y5-40 77 14],'String',num2str(get(aedi55,'String')));
aedi56 =uicontrol('Style','edit','Position',[545 y5-60 77 20],'String',par_2g(5,6),'Callback',['set(atex56,''String'',','num2str(get(aedi56,''String''))),'],'BackGroundColor',[0.7 0.7 0.7]);
atex56 =uicontrol('Style','text','Position',[545 y5-40 77 14],'String',num2str(get(aedi56,'String')));



else

% Hier im else-Fall werden die Grundeinstellungen
% fr den ReDuS-Regler wiederhergestellt, falls
% die Datei "par_2g.mat" gelscht wurde oder noch nicht angelegt wurde.. 
 

aedi11 =uicontrol('Style','edit','Position',[29 y1-60 77 20],'String',1,'Callback',['set(atex11,''String'',','num2str(get(aedi11,''String''))),'],'BackGroundColor',[0.7 0.7 0.7]);
atex11 =uicontrol('Style','text','Position',[29 y1-40 77 14],'String',num2str(get(aedi11,'String')));
aedi12 =uicontrol('Style','edit','Position',[132 y1-60 77 20],'String',1,'Callback',['set(atex12,''String'',','num2str(get(aedi12,''String''))),'],'BackGroundColor',[0.7 0.7 0.7]);
atex12 =uicontrol('Style','text','Position',[132 y1-40 77 14],'String',num2str(get(aedi12,'String')));

aedi13 =uicontrol('Style','edit','Position',[235 y1-60 77 20],'String',0,'Callback',['set(atex13,''String'',','num2str(get(aedi13,''String''))),'],'BackGroundColor',[0.7 0.7 0.7]);
atex13 =uicontrol('Style','text','Position',[235 y1-40 77 14],'String',num2str(get(aedi13,'String')));
aedi14 =uicontrol('Style','edit','Position',[338 y1-60 77 20],'String',0,'Callback',['set(atex14,''String'',','num2str(get(aedi14,''String''))),'],'BackGroundColor',[0.7 0.7 0.7]);
atex14 =uicontrol('Style','text','Position',[338 y1-40 77 14],'String',num2str(get(aedi14,'String')));
aedi15 =uicontrol('Style','edit','Position',[442 y1-60 77 20],'String',-9.81,'Callback',['set(atex15,''String'',','num2str(get(aedi15,''String''))),'],'BackGroundColor',[0.7 0.7 0.7]);
atex15 =uicontrol('Style','text','Position',[442 y1-40 77 14],'String',num2str(get(aedi15,'String')));

aedi16 =uicontrol('Style','edit','Position',[545 y1-60 77 20],'String',45,'Callback',['set(atex16,''String'',','num2str(get(aedi16,''String''))),'],'BackGroundColor',[0.7 0.7 0.7]);
atex16 =uicontrol('Style','text','Position',[545 y1-40 77 14],'String',num2str(get(aedi16,'String')));
aedi17 =uicontrol('Style','edit','Position',[648 y1-60 77 20],'String',60,'Callback',['set(atex17,''String'',','num2str(get(aedi17,''String''))),'],'BackGroundColor',[0.7 0.7 0.7]);
atex17 =uicontrol('Style','text','Position',[648 y1-40 77 14],'String',num2str(get(aedi17,'String')));

% Vorgabe der Parameter teta1, teta2, d1, d2, a1, a2 ,alpha1, alpha2 (RV2)
aedi21 =uicontrol('Style','edit','Position',[29 y2-60 77 20],'String',0,'Callback',['set(atex21,''String'',','num2str(get(aedi21,''String''))),'],'BackGroundColor',[0.7 0.7 0.7]);
atex21 =uicontrol('Style','text','Position',[29 y2-40 77 14],'String',num2str(get(aedi21,'String')));
aedi22 =uicontrol('Style','edit','Position',[122 y2-60 77 20],'String',-pi/2,'Callback',['set(atex22,''String'',','num2str(get(aedi22,''String''))),'],'BackGroundColor',[0.7 0.7 0.7]);
atex22 =uicontrol('Style','text','Position',[122 y2-40 77 14],'String',num2str(get(aedi22,'String')));

aedi23 =uicontrol('Style','edit','Position',[215 y2-60 77 20],'String',0,'Callback',['set(atex23,''String'',','num2str(get(aedi23,''String''))),'],'BackGroundColor',[0.7 0.7 0.7]);
atex23 =uicontrol('Style','text','Position',[215 y2-40 77 14],'String',num2str(get(aedi23,'String')));
aedi24 =uicontrol('Style','edit','Position',[308 y2-60 77 20],'String',0,'Callback',['set(atex24,''String'',','num2str(get(aedi24,''String''))),'],'BackGroundColor',[0.7 0.7 0.7]);
atex24 =uicontrol('Style','text','Position',[308 y2-40 77 14],'String',num2str(get(aedi24,'String')));

aedi25 =uicontrol('Style','edit','Position',[402 y2-60 77 20],'String',0.28,'Callback',['set(atex25,''String'',','num2str(get(aedi25,''String''))),'],'BackGroundColor',[0.7 0.7 0.7]);
atex25 =uicontrol('Style','text','Position',[402 y2-40 77 14],'String',num2str(get(aedi25,'String')));
aedi26 =uicontrol('Style','edit','Position',[495 y2-60 77 20],'String',1.365,'Callback',['set(atex26,''String'',','num2str(get(aedi26,''String''))),'],'BackGroundColor',[0.7 0.7 0.7]);
atex26 =uicontrol('Style','text','Position',[495 y2-40 77 14],'String',num2str(get(aedi26,'String')));

aedi27 =uicontrol('Style','edit','Position',[588 y2-60 77 20],'String',-pi/2,'Callback',['set(atex27,''String'',','num2str(get(aedi27,''String''))),'],'BackGroundColor',[0.7 0.7 0.7]);
atex27 =uicontrol('Style','text','Position',[588 y2-40 77 14],'String',num2str(get(aedi27,'String')));
aedi28 =uicontrol('Style','edit','Position',[681 y2-60 77 20],'String',0,'Callback',['set(atex28,''String'',','num2str(get(aedi28,''String''))),'],'BackGroundColor',[0.7 0.7 0.7]);
atex28 =uicontrol('Style','text','Position',[681 y2-40 77 14],'String',num2str(get(aedi28,'String')));


% Eingabe von s1 und s2 , FD1 FD2

aedi31 =uicontrol('Style','edit','Position',[30 y3-60 77 20],'String',-0.1,'Callback',['set(atex31,''String'',','num2str(get(aedi31,''String''))),'],'BackGroundColor',[0.7 0.7 0.7]);
atex31 =uicontrol('Style','text','Position',[30 y3-40 77 14],'String',num2str(get(aedi31,'String')));
aedi32 =uicontrol('Style','edit','Position',[133 y3-60 77 20],'String',0,'Callback',['set(atex32,''String'',','num2str(get(aedi32,''String''))),'],'BackGroundColor',[0.7 0.7 0.7]);
atex32 =uicontrol('Style','text','Position',[133 y3-40 77 14],'String',num2str(get(aedi32,'String')));
aedi33 =uicontrol('Style','edit','Position',[236 y3-60 77 20],'String',0,'Callback',['set(atex33,''String'',','num2str(get(aedi33,''String''))),'],'BackGroundColor',[0.7 0.7 0.7]);
atex33 =uicontrol('Style','text','Position',[236 y3-40 77 14],'String',num2str(get(aedi33,'String')));

aedi34 =uicontrol('Style','edit','Position',[339 y3-60 77 20],'String',-0.7,'Callback',['set(atex34,''String'',','num2str(get(aedi34,''String''))),'],'BackGroundColor',[0.7 0.7 0.7]);
atex34 =uicontrol('Style','text','Position',[339 y3-40 77 14],'String',num2str(get(aedi34,'String')));
aedi35 =uicontrol('Style','edit','Position',[442 y3-60 77 20],'String',0,'Callback',['set(atex35,''String'',','num2str(get(aedi35,''String''))),'],'BackGroundColor',[0.7 0.7 0.7]);
atex35 =uicontrol('Style','text','Position',[442 y3-40 77 14],'String',num2str(get(aedi35,'String')));
aedi36 =uicontrol('Style','edit','Position',[545 y3-60 77 20],'String',0,'Callback',['set(atex36,''String'',','num2str(get(aedi36,''String''))),'],'BackGroundColor',[0.7 0.7 0.7]);
atex36 =uicontrol('Style','text','Position',[545 y3-40 77 14],'String',num2str(get(aedi36,'String')));

aedi37 =uicontrol('Style','edit','Position',[648 y3-60 77 20],'String',0,'Callback',['set(atex37,''String'',','num2str(get(aedi37,''String''))),'],'BackGroundColor',[0.7 0.7 0.7]);
atex37 =uicontrol('Style','text','Position',[648 y3-40 77 14],'String',num2str(get(aedi37,'String')));
aedi38 =uicontrol('Style','edit','Position',[751 y3-60 77 20],'String',0,'Callback',['set(atex38,''String'',','num2str(get(aedi38,''String''))),'],'BackGroundColor',[0.7 0.7 0.7]);
atex38 =uicontrol('Style','text','Position',[751 y3-40 77 14],'String',num2str(get(aedi38,'String')));

% Eingabe von I1 und I2 (Hauptdiagonale)

aedi41 =uicontrol('Style','edit','Position',[30 y4-60 77 20],'String',0.9,'Callback',['set(atex41,''String'',','num2str(get(aedi41,''String''))),'],'BackGroundColor',[0.7 0.7 0.7]);
atex41 =uicontrol('Style','text','Position',[30 y4-40 77 14],'String',num2str(get(aedi41,'String')));
aedi42 =uicontrol('Style','edit','Position',[133 y4-60 77 20],'String',1.3,'Callback',['set(atex42,''String'',','num2str(get(aedi42,''String''))),'],'BackGroundColor',[0.7 0.7 0.7]);
atex42 =uicontrol('Style','text','Position',[133 y4-40 77 14],'String',num2str(get(aedi42,'String')));
aedi43 =uicontrol('Style','edit','Position',[236 y4-60 77 20],'String',1.3,'Callback',['set(atex43,''String'',','num2str(get(aedi43,''String''))),'],'BackGroundColor',[0.7 0.7 0.7]);
atex43 =uicontrol('Style','text','Position',[236 y4-40 77 14],'String',num2str(get(aedi43,'String')));
aedi44 =uicontrol('Style','edit','Position',[339 y4-60 77 20],'String',2,'Callback',['set(atex43,''String'',','num2str(get(aedi43,''String''))),'],'BackGroundColor',[0.7 0.7 0.7]);
atex44 =uicontrol('Style','text','Position',[339 y4-40 77 14],'String',num2str(get(aedi43,'String')));
aedi45 =uicontrol('Style','edit','Position',[442 y4-60 77 20],'String',1.8,'Callback',['set(atex43,''String'',','num2str(get(aedi43,''String''))),'],'BackGroundColor',[0.7 0.7 0.7]);
atex45 =uicontrol('Style','text','Position',[442 y4-40 77 14],'String',num2str(get(aedi43,'String')));
aedi46 =uicontrol('Style','edit','Position',[545 y4-60 77 20],'String',1.6,'Callback',['set(atex43,''String'',','num2str(get(aedi43,''String''))),'],'BackGroundColor',[0.7 0.7 0.7]);
atex46 =uicontrol('Style','text','Position',[545 y4-40 77 14],'String',num2str(get(aedi43,'String')));

% Eingabe der externen Krfte/Momente

aedi51 =uicontrol('Style','edit','Position',[30 y5-60 77 20],'String',0,'Callback',['set(atex51,''String'',','num2str(get(aedi51,''String''))),'],'BackGroundColor',[0.7 0.7 0.7]);
atex51 =uicontrol('Style','text','Position',[30 y5-40 77 14],'String',num2str(get(aedi51,'String')));
aedi52 =uicontrol('Style','edit','Position',[133 y5-60 77 20],'String',0,'Callback',['set(atex52,''String'',','num2str(get(aedi52,''String''))),'],'BackGroundColor',[0.7 0.7 0.7]);
atex52 =uicontrol('Style','text','Position',[133 y5-40 77 14],'String',num2str(get(aedi52,'String')));
aedi53 =uicontrol('Style','edit','Position',[236 y5-60 77 20],'String',0,'Callback',['set(atex53,''String'',','num2str(get(aedi53,''String''))),'],'BackGroundColor',[0.7 0.7 0.7]);
atex53 =uicontrol('Style','text','Position',[236 y5-40 77 14],'String',num2str(get(aedi53,'String')));
aedi54 =uicontrol('Style','edit','Position',[339 y5-60 77 20],'String',0,'Callback',['set(atex54,''String'',','num2str(get(aedi54,''String''))),'],'BackGroundColor',[0.7 0.7 0.7]);
atex54 =uicontrol('Style','text','Position',[339 y5-40 77 14],'String',num2str(get(aedi54,'String')));
aedi55 =uicontrol('Style','edit','Position',[442 y5-60 77 20],'String',0,'Callback',['set(atex55,''String'',','num2str(get(aedi55,''String''))),'],'BackGroundColor',[0.7 0.7 0.7]);
atex55 =uicontrol('Style','text','Position',[442 y5-40 77 14],'String',num2str(get(aedi55,'String')));
aedi56 =uicontrol('Style','edit','Position',[545 y5-60 77 20],'String',0,'Callback',['set(atex56,''String'',','num2str(get(aedi56,''String''))),'],'BackGroundColor',[0.7 0.7 0.7]);
atex56 =uicontrol('Style','text','Position',[545 y5-40 77 14],'String',num2str(get(aedi56,'String')));


end


% Pushbutton, der den weiteren Programmablauf startet.

apus1=uicontrol('Style','PushButton','Position',[ 63 35 380 20],'String','Eingestellte Parameter bernehmen !    ','Callback','P_ne2_sp');
apus2=uicontrol('Style','PushButton','Position',[ 63 10 380 20],'String','Newton-Euler Verfahren durchfhren !    ','Callback','N_E_2Ga');
