%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Vorwrtstransformation fr den RRT-Roboter aus Bild (2.22)
%  W. Weber, Februar 2002
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
syms teta1 teta2 teta3 alpha1 alpha2 alpha3 a1 a2 a3 d1 d2 d3 l1
syms TW T10 T21 T32; % Frames 

T10=[cos(teta1) -sin(teta1)*cos(alpha1) sin(teta1)*sin(alpha1) a1*cos(teta1);...
      sin(teta1) cos(teta1)*cos(alpha1) -cos(teta1)*sin(alpha1) a1*sin(teta1);...
      0 sin(alpha1) cos(alpha1) d1;...
   0 0 0 1];

T21=[cos(teta2) -sin(teta2)*cos(alpha2) sin(teta2)*sin(alpha2) a2*cos(teta2);...
      sin(teta2) cos(teta2)*cos(alpha2) -cos(teta2)*sin(alpha2) a2*sin(teta2);...
      0 sin(alpha2) cos(alpha2) d2;...
   0 0 0 1];

T32=[cos(teta3) -sin(teta3)*cos(alpha3) sin(teta3)*sin(alpha3) a3*cos(teta3);...
      sin(teta3) cos(teta3)*cos(alpha3) -cos(teta3)*sin(alpha3) a3*sin(teta3);...
      0 sin(alpha3) cos(alpha3) d3;...
   0 0 0 1];

% Allgemeine Vorwrtstransformation fr ein Dreigelenk-Roboter
TW=T10*T21*T32;

% Hier: Lsung allgemein fr RRT-Roboter Bild 2.22
teta3_num=0; d1=-l1; d2_num=0;  a1_num=0; a2_num=0; a3_num=0;
alpha1_num=pi/2; alpha2_num=pi/2; alpha3_num=0;
teta3=teta3_num; d2=d2_num; a1=a1_num, a2=a2_num; a3=a3_num;
alpha1=sym(alpha1_num,'f'); alpha2=alpha2_num; alpha3=alpha3_num;

if double(cos(alpha1_num)) < 0.000001
   T10(1,2)=0; T10(2,2)=0; T10(3,3)=0;
end
if abs(1-double(sin(alpha1_num))) < 0.000001 
   T10(3,2)=1; T10(1,3)=sin(teta1); T10(2,3)=-cos(teta1);
   
end

if double(cos(alpha2_num)) < 0.000001
   T21(1,2)=0; T21(2,2)=0; T21(3,3)=0;
   end

 if double(cos(teta3_num)) < 0.000001
   T32(1,1)=0; T32(2,2)=0; T10(2,3)=0; T10(1,4)=0;
   end
  
   
   %A10(ix,jx)=round(A10(ix,jx));


T10_num1=eval(T10)
T21_num1=eval(T21)
T32_num1=eval(T32)

TW_num1=T10_num1*T21_num1*T32_num1

teta1_num=pi/2;
teta2_num=-pi/4;
d3_num=0.5;

if abs(cos(teta1_num)) < 0.000001
   T10_num1(1,1)=0; T10_num1(2,2)=0; T10_num1(2,3)=0; T10_num1(1,4)=0;
end
if abs(1-double(sin(teta1_num))) < 0.000001 
   T10_num1(2,1)=1; 
   end
 TW_num1=T10_num1*T21_num1*T32_num1

  teta1=teta1_num
teta2=teta2_num
d3=d3_num
l1=1
TW_num2=eval(TW_num1)

% Runden, wenn gebr. Anteil < 1*10-6
%for ix=1:4
%	for jx=1:4
%		t_str=class(T10_num1(ix,jx)) 
 %     if strcmp(t_str,'double')
 %     	if abs(T10_num1(ix,jx)-round(T21(ix,jx))) < 0.000001
 %     	T10_num1(ix,jx)=round(T10_num1(ix,jx));
 %    		 end
%		end
%	end
%end




